# ==================================================================
#           Name: No Chat Spam
#           Author: Thomas Morton
#           Updated: 20/04/2008
# ==================================================================

import es
import langlib
import playerlib
import services
import gamethread
import popuplib

import time
import urllib
import urllib2
from configobj import ConfigObj

#plugin information
info = es.AddonInfo() 
info.name     = 'No Chat Spam' 
info.version  = '1.0.1' 
info.url      = 'http://addons.eventscripts.com/addons/view/nochatspam' 
info.basename = 'nochatspam' 
info.author   = 'Errant'

# this is the new version!!

'''
 ++ No Chat Spam 1.0 ++
   by Errant
   
 Stop evil chat spammers :) 
 
 Uses a fairly long list of known spam chat strings (from hacker plugins) and kills them
 Various player punishments are available
'''

banned_text=[]
cfg={}
text=None
players={}
auth=None
update_available=0
script_update_available=0
adminlist=[]

pvar=es.ServerVar("ncs_ver")
pvar.set(str(info.version))
pvar.makepublic()

def check_for_updates():
    '''
        Checks my server for the latest updates
    '''
    fp = urllib.urlopen("http://ncs.livemeta.net/version.txt")
    cver = open("%s/data/cver.txt" % es.getAddonPath("nochatspam"),"r")
    cversion=int(cver.read())
    nversion=int(fp.read())
    fp.close()
    cver.close()
    if nversion != cversion:
        return True
    return None

def download_strings_update():
    '''
        Downloads the latest chat strings file
    '''
    urllib.urlretrieve("http://ncs.livemeta.net/chat_spam_strings.txt","%s/data/chat_spam_strings.txt" % es.getAddonPath("nochatspam"))
    urllib.urlretrieve("http://ncs.livemeta.net/version.txt","%s/data/cver.txt" % es.getAddonPath("nochatspam"))
    update_available=0
    
def check_for_script_updates():
    fp = urllib.urlopen("http://ncs.livemeta.net/script_version.txt")
    nversion=str(fp.read())
    fp.close()
    if nversion != str(info.version):
        return True
    return None
    
def download_script_update():
    '''
        Downloads the latest chat strings file
    '''
    urllib.urlretrieve("http://ncs.livemeta.net/latest.txt","%s/nochatspam.py" % es.getAddonPath("nochatspam"))
    script_update_available=0
    
def load_chat_strings():
    '''
        Parse the text into a file
    '''
    fp = open("%s/data/chat_spam_strings.txt" % es.getAddonPath("nochatspam"),"r")
    for line in fp.readlines():
        banned_text.append(line.strip("\n"))
    fp.close()
    fp = open("%s/cfg/custom_chat_strings.txt" % es.getAddonPath("nochatspam"),"r")
    for line in fp.readlines():
        if not line.startswith("//"):
            banned_text.append(str(line.strip("\n")))
    fp.close()

def load_adminlist():
    '''
        Loads the admins from a txt file if need be
    '''
    fp = open("%s/cfg/adminlist.txt" % es.getAddonPath("nochatspam"),"r")
    for line in fp.readlines():
        if not line.startswith("//"):
            adminlist.append(line.strip("\n"))
    fp.close()
    
def load_cfg():
    '''
        Loads the scripts cfg options
    '''
    global cfg
    cfg = ConfigObj("%s/cfg/cfg.ini" % es.getAddonPath("nochatspam")) 

def load_strings():
    '''
        Loads the langlib strings
    '''
    global text
    text=langlib.Strings("%s/cfg/strings.ini" % es.getAddonPath("nochatspam"))
    
def update_everything():
    user = es.getcmduserid()
    steam = es.getplayersteamid(user)
    if auth:
        if not auth.isUseridAuthorized(user, "ncs_admin"):
            return None
    elif str(steam) not in adminlist:
        return None
    if check_for_updates():
        es.msg("#multi","#green[NCS] #lightgreen%s" % text("update_message"))
        download_strings_update()
        load_chat_strings()
    if check_for_script_updates():
        es.msg("#multi","#green[NCS] #lightgreen%s" % text("update_message"))
        download_script_update()
        gamethread.delayed(10,es.server.queuecmd,("es_reload nochatspam"))
    
def load():
    global update_available
    load_cfg()
    load_chat_strings()
    load_strings()
    if check_for_updates():
        if cfg["update_on_load"] == "1":
            es.msg("#multi","#green[NCS] #lightgreen%s" % text("update_message"))
            download_strings_update()
            load_chat_strings()
        else:
            update_available=1
    if check_for_script_updates():
        if cfg["update_on_load"] == "1":
            es.msg("#multi","#green[NCS] #lightgreen%s" % text("update_message"))
            download_script_update()
            gamethread.delayed(10,es.server.queuecmd,("es_reload nochatspam"))
        else:
            script_update_available=0
    es.addons.registerSayFilter(filter)
    if es.exists("saycommand","!ncs"):
        es.unregsaycmd("!ncs")
    es.regsaycmd("!ncs","nochatspam/sayblock" "Say command to update NCS")
    try:
        auth = services.use("auth")
        # register the capapbility
        auth.registerCapability("ncs_admin", auth.ADMIN)
    except:
        auth=None
    load_adminlist()
    es.msg("#multi","#green[NCS] #lightgreen%s" % text("load_message"))
    
def es_map_start():
    if check_for_updates() and cfg["update_on_map_start"] == "1":
        es.msg("#multi","#green[NCS] #lightgreen%s" % text("update_message"))
        download_strings_update()
        load_chat_strings()
    if check_for_script_updates():
        if cfg["update_on_load"] == "1":
            es.msg("#multi","#green[NCS] #lightgreen%s" % text("update_message"))
            download_script_update()
            gamethread.delayed(10,es.server.queuecmd,("es_reload nochatspam"))
        else:
            script_update_available=0 
def unload():
    es.addons.unregisterSayFilter(filter)
    es.msg("#multi","#green[NCS] #lightgreen%s" % text("unload_message"))

    
def send_admin_menu(userid):
    if auth.isUseridAuthorized(userid, "ncs_admin"):
        amenu.send(userid)
        
    
def filter(userid,message,teamonly):
    msg=message.strip("\"")
    if str(msg) in banned_text:
        # warn the player?
        if cfg["warn_player"] == "1":
            es.tell(userid,"#multi","#green[NCS] #lightgreen%s" % text("player_warn_banned_strings",None,playerlib.Player(userid).get("lang")))
        return 0,"",teamonly
    if cfg["check_for_time_spam"] == "1":
        if userid not in players:
            players[userid]=0
        if (int(time.time()) - players[userid]) < int(cfg["time_spam_limit"]):
            if cfg["warn_player"] == "1":
                es.tell(userid,"#multi","#green[NCS] #lightgreen%s" % text("player_warn_time_spam",None,playerlib.Player(userid).get("lang")))
            return 0,"",teamonly 
        players[userid]=int(time.time())
    return userid,message,teamonly